package com.example.client;

import com.example.client.data.Country;
import com.example.client.data.CountryData;
import com.example.client.data.CountryProperties;
import com.example.client.data.Stock;
import com.example.client.data.StockData;
import com.example.client.data.StockProperties;
import com.example.client.widgets.ComboboxStock;
import com.google.gwt.core.client.GWT;
import com.google.gwt.core.client.EntryPoint;
import com.sencha.gxt.core.client.XTemplates;
import com.sencha.gxt.core.client.util.Format;
import com.sencha.gxt.core.client.util.Margins;
import com.google.gwt.event.logical.shared.SelectionEvent;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.safehtml.shared.SafeHtml;
import com.google.gwt.safehtml.shared.SafeUri;
import com.google.gwt.safehtml.shared.UriUtils;
import com.google.gwt.text.shared.AbstractSafeHtmlRenderer;
import com.google.gwt.user.client.ui.IsWidget;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.Widget;
import com.sencha.gxt.cell.core.client.form.ComboBoxCell.TriggerAction;
import com.sencha.gxt.data.shared.ListStore;
import com.sencha.gxt.widget.core.client.info.Info;
import com.sencha.gxt.widget.core.client.ContentPanel;
import com.sencha.gxt.widget.core.client.form.ComboBox;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer;
import com.sencha.gxt.widget.core.client.container.VerticalLayoutContainer.VerticalLayoutData;

/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class Gxt_combobox implements IsWidget, EntryPoint
{
	public  static ListStore<Stock>   STORE     = null;
	private        ListStore<Country> COUNTIRES = null;
	private        ComboBox<Stock>    combo1    = null;
	private        ComboBox<Country>  combo2    = null;
    private        ISafeHtml          iSafeHtml = null;

    private        StockProperties    sprops    = null;
    private        CountryProperties  cprops    = null;	

    private  final  String  URL_TEMPL = "{0}images/flags/{1}.png";
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    interface ISafeHtml extends XTemplates 
	{
		@XTemplate("<img width=\"16\" src=\"{imageUri}\">&nbsp;{name}")
		SafeHtml country(SafeUri imageUri, String name);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void createStores()
	{
		sprops = GWT.create(StockProperties  .class);
		cprops = GWT.create(CountryProperties.class);
		
		STORE = new ListStore<Stock>(sprops.key());
		STORE.addAll(StockData.getStocks());
	   
		COUNTIRES = new ListStore<Country>(cprops.abbr());
		COUNTIRES.addAll(CountryData.getCountries());
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SelectionHandler<Stock> selectStock = new SelectionHandler<Stock>()
	{
		@Override
		public void onSelection(SelectionEvent<Stock> selectionEvent) {
			/*
			 * Очистка фильтра, устанавливаемого вводом символов с клавиатуры
			 */
			if ((STORE != null) && (STORE.getFilters() != null) &&
				                   (STORE.getFilters().size() > 0))
				STORE.removeFilters();
		}		
	};
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void createCombobox1()
	{
		combo1 = new ComboBox<Stock>(STORE, sprops.symbolLabel());
		combo1.setEmptyText("Select a company...");
//		combo1.setName("simpleCombo");
//		combo1.setForceSelection(false);
		combo1.setTypeAhead(true);
		combo1.setTriggerAction(TriggerAction.ALL);
		combo1.setWidth(180);
		
		combo1.addSelectionHandler(selectStock);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	private void createCombobox2()
	{
		iSafeHtml = GWT.create(ISafeHtml.class);
		combo2 = new ComboBox<Country>(COUNTIRES, cprops.name(),
                               new AbstractSafeHtmlRenderer<Country>() {
			@Override
			public SafeHtml render(Country item)
			{
				String url = Format.substitute(URL_TEMPL, 
						                       GWT.getHostPageBaseURL(),
                                               item.getAbbr());
				SafeUri imageUri = UriUtils.fromString(url);
				return iSafeHtml.country(imageUri, item.getName());
			}
		});
		combo2.setWidth(180);
		combo2.setTypeAhead(true);
		combo2.setTriggerAction(TriggerAction.ALL);
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	SelectionHandler<Stock> handler = new SelectionHandler<Stock>() {
		@Override
		public void onSelection(SelectionEvent<Stock> selectionEvent) {
			Stock stock = selectionEvent.getSelectedItem();
			Info.display("SelectionHandler", stock.getName());
		}
	};
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	@Override
	public Widget asWidget()
	{
		ContentPanel panel = new ContentPanel();
		panel.setHeadingText("GXT ComboBox");
		panel.setPixelSize(240, 180);
		panel.addStyleName("margin-5");

		createStores   ();
		createCombobox1();
		createCombobox2();
		ComboboxStock combo3 = new ComboboxStock(handler);

		Margins margins = new Margins(10, 6, 0, 6);

		VerticalLayoutContainer vlc = new VerticalLayoutContainer();
		vlc.add(combo1, new VerticalLayoutData(-1, -1, margins));
		vlc.add(combo2, new VerticalLayoutData(-1, -1, margins));
		vlc.add(combo3, new VerticalLayoutData( 1, -1, margins));
		
		panel.add(vlc);
		return panel;
	}
	//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad()
	{
		RootPanel.get("wrapper").add(asWidget());
	}
}
