package com.example.client.widgets;

import com.example.client.Gxt_combobox;
import com.example.client.data.Stock;
import com.example.client.data.StockProperties;
import com.google.gwt.event.logical.shared.SelectionHandler;
import com.google.gwt.user.client.ui.Widget;
import com.google.gwt.user.client.ui.IsWidget;
import com.google.gwt.core.client.GWT;
import com.sencha.gxt.core.client.IdentityValueProvider;
import com.sencha.gxt.widget.core.client.ListView;
import com.sencha.gxt.widget.core.client.form.ComboBox;
import com.sencha.gxt.cell.core.client.form.ComboBoxCell;
import com.sencha.gxt.cell.core.client.form.ComboBoxCell.TriggerAction;

public class ComboboxStock implements IsWidget
{
	private  ComboBox <Stock>  comboBox   = null;
	private  StockProperties   properties = null;
	
	@Override
	public Widget asWidget()
	{
		return comboBox;
	}
	
	public ComboboxStock (SelectionHandler<Stock> handler)
	{
		properties = GWT.create(StockProperties.class);
		createComboBox(handler);
	}

	ComboBox<Stock> createComboBox(SelectionHandler<Stock> handler)
	{
		ListView<Stock, Stock>       listView  = null;
		IdentityValueProvider<Stock> identity  = null;
		StockCell                    stockCell = null;
		ComboBoxCell<Stock>          comboCell = null;

		identity  = new IdentityValueProvider<Stock>();
		stockCell = new StockCell();
		listView  = new ListView<Stock, Stock>(Gxt_combobox.STORE, 
				                               identity, stockCell);
		comboCell = new ComboBoxCell<Stock>   (Gxt_combobox.STORE, 
				                               properties.symbolLabel(),
				                               listView);		
		comboBox = new ComboBox<Stock>(comboCell);
		comboBox.setEditable(false);
		comboBox.setTriggerAction(TriggerAction.ALL);
		comboBox.setWidth(80);

		comboBox.addSelectionHandler(handler);
//		comboBox.addSelectionHandler(new SelectionHandler<Stock>() {
//			@Override
//			public void onSelection(SelectionEvent<Stock> event) {
//				handler.onSelection(event);
//			}
//		});
		return comboBox;
	}
}
